package ru.dbotthepony.mc.otm.menu.data;

import net.minecraft.world.inventory.ContainerData;

import java.util.UUID;

public class UUIDDataContainer implements ContainerData {
	public static final int NETWORK_PAYLOAD_SIZE = 8;

	private UUID value;
	private final int[] buffer = new int[NETWORK_PAYLOAD_SIZE];

	public UUID getValue() {
		if (value != null) {
			return value;
		}

		long a = buffer[0];
		long b = buffer[1];
		long c = buffer[2];
		long d = buffer[3];

		long upper = a | b << 16 | c << 32 | d << 48;

		a = buffer[4];
		b = buffer[5];
		c = buffer[6];
		d = buffer[7];

		long lower = a | b << 16 | c << 32 | d << 48;

		return value = new UUID(upper, lower);
	}

	public void setValue(UUID value) {
		if (value.equals(this.value)) {
			return;
		}

		this.value = value;

		long long_value = value.getMostSignificantBits();

		buffer[0] = (int) ((long_value) & 0xFFFF);
		buffer[1] = (int) ((long_value >>> 16) & 0xFFFF);
		buffer[2] = (int) ((long_value >>> 32) & 0xFFFF);
		buffer[3] = (int) ((long_value >>> 48) & 0xFFFF);

		long_value = value.getLeastSignificantBits();

		buffer[4] = (int) ((long_value) & 0xFFFF);
		buffer[5] = (int) ((long_value >>> 16) & 0xFFFF);
		buffer[6] = (int) ((long_value >>> 32) & 0xFFFF);
		buffer[7] = (int) ((long_value >>> 48) & 0xFFFF);
	}

	// override
	protected void updateValue() {

	}

	@Override
	public int get(int index) {
		updateValue();
		return buffer[index];
	}

	@Override
	public void set(int index, int _value) {
		if (buffer[index] == _value)
			return;

		value = null;
		buffer[index] = _value;
	}

	@Override
	public int getCount() {
		return NETWORK_PAYLOAD_SIZE;
	}
}
