package ru.dbotthepony.mc.otm.menu.slot;

import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.capability.matter.IMatterHandler;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;

import java.util.Optional;

public class MatterContainerInputSlot extends MatterySlot {
	public boolean auto_bg;
	public IMatterHandler.MatterDirection desired_direction;

	public MatterContainerInputSlot(Container p_40223_, int p_40224_, int p_40225_, int p_40226_, boolean auto_bg, IMatterHandler.MatterDirection desired_direction) {
		super(p_40223_, p_40224_, p_40225_, p_40226_);
		this.auto_bg = auto_bg;
		this.desired_direction = desired_direction;
	}

	@Override
	public boolean mayPlace(ItemStack p_40231_) {
		Optional<IMatterHandler> handler = p_40231_.getCapability(MatteryCapability.MATTER).resolve();

		if (handler.isEmpty())
			return false;

		IMatterHandler.MatterDirection direction = handler.get().getDirection();

		return direction == IMatterHandler.MatterDirection.BIDIRECTIONAL || desired_direction == direction;
	}
}
