package ru.dbotthepony.mc.otm.menu.widget

import net.minecraft.world.inventory.ContainerData
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import java.util.function.Consumer

abstract class AbstractWidget constructor(
	@JvmField val menu: MatteryMenu,
) {
	lateinit var data_registry: Consumer<ContainerData>

	init {
		menu.addWidget(this) {
			data_registry = it
		}
	}

	abstract fun updateServer()

	protected fun addDataSlots(slots: ContainerData) {
		data_registry.accept(slots)
	}
}
